# factor.rb -- an example of Ruby/MathLink library.
# To run this program use the command-line below:
#      Unix:           ruby factor.rb -linkname "math -mathlink"
#      Mac or Windows: ruby factor.rb -linkname launch
# This example is ports of ${MATHLINK}/MathLinkExamples/factor.c
# See also factor.c.

require 'mathematica/mathlink'

include Mathematica
include MathLink

def error(link)
  if (link.error)
	printf STDERR, "Error detected by MathLink: %s.\n", link.error_message
  else
	printf STDERR, "Error detetected by this program.\n"
  end

  exit 3
end

link = MathLink.new.open(ARGV.size, ARGV)

print 'Integer to factor: '
num = STDIN.gets

link.put_function('EvaluatePacket', 1)
link.put_function('FactorInteger', 1)
link.put_integer(num)
link.end_packet

while((pkt = link.next_packet) && pkt != RETURNPKT)
  link.new_packet
  error(link) if (link.error)
end

error(link) if (! (len = link.check_function('List')))

1.upto(len) do |k|
  if((len = link.check_function('List')) && len == 2 &&
	 (prime = link.get_integer) && (expt = link.get_integer))
	printf "%d ^ %d\n", prime, expt
  else
	error(link)
  end
end

link.put_function('Exit', 0)

