# factor3.rb -- an example of Ruby/MathLink library.
# To run this program use the command-line below:
#      Unix:           ruby factor3.rb -linkname "math -mathlink"
#      Mac or Windows: ruby factor3.rb -linkname launch
# This example is ports of ${MATHLINK}/MathLinkExamples/factor3.c
# See also factor3.c.

require 'mathematica/mathlink'

include Mathematica
include MathLink

def error(link)
  if (link.error)
	printf STDERR, "Error detected by MathLink: %s.\n", link.error_message
  else
	printf STDERR, "Error detetected by this program.\n"
  end

  exit 3
end

def read_and_print_function(link, indent)
  return 0 if ((len = link.get_arg_count) == 0)

  indent += 3
  printf "\n%*.*s", indent, indent, ''
  
  return 0 if (read_and_print_expression(link, indent) == 0)
  print '['

  1.upto(len) do |i|
	return 0 if (read_and_print_expression(link, indent) == 0)
	print ', ' if (i < len)
  end
  print ']'
  indent -= 3

  1
end

def read_and_print_atom(link, tag)
  print '\"' if (tag == MLTKSTR)
  if (s = link.get_string)
	printf '%s', s
	link.disown_string s
  end
  print '"' if tag == MLTKSTR
  print ' '
  return (link.error == MLEOK)
end

def read_and_print_expression(link, indent)
  tag = link.get_next
  case tag
  when MLTKSYM, MLTKSTR, MLTKINT, MLTKREAL
	return read_and_print_atom(link, tag)
  when MLTKFUNC
	return read_and_print_function(link, indent)
  else
	return 0
  end
end

link = MathLink.new.open(ARGV.size, ARGV)

print 'Integer to factor: '
num = STDIN.gets

link.put_function('EvaluatePacket', 1)
link.put_function('FactorInteger', 1)
link.put_next(MLTKINT)
link.put_byte_string(num, num.length)
link.end_packet

while((pkt = link.next_packet) && pkt != RETURNPKT)
  link.new_packet
  error(link) if link.error
end

read_and_print_expression(link, 0)
puts

link.put_function('Exit', 0)

