# quotient.rb -- an example of Ruby/MathLink library.
# To run this program use the command-line below:
#      Unix:           ruby quotient.rb -linkname "math -mathlink"
#      Mac or Windows: ruby quotient.rb -linkname launch
# This example is ports of ${MATHLINK}/MathLinkExamples/quotient.c
# See also quotient.c

require 'mathematica/mathlink'

include Mathematica
include MathLink

link = MathLink.new.open(ARGV.size, ARGV)

print 'Two integers m/n: '
a = STDIN.gets.chop.scan(/(\d+)[\/| ](\d+)/)
if a.size == 0
  exit -1
else
  m, n = a[0]
end

link.put_function('EvaluatePacket', 1)
link.put_function('Quotient', 2)
link.put_integer(m)
link.put_integer(n)
link.end_packet

while((pkt = link.next_packet) && pkt != RETURNPKT)
  link.new_packet
end

q = link.get_integer

printf "quotient = %d\n", q

link.put_function('Exit', 0)

0

